<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>task 26.10 Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <h2 class="text-center">Danh sách đơn hàng</h2>
                <table class="table text-center table-striped" id="table-order">
                    <thead>
                        <tr>
                            <th scope="col">Order Code</th>
                            <th scope="col">Kích cỡ combo</th>
                            <th scope="col">Loại pizza</th>
                            <th scope="col">Nước uống</th>
                            <th scope="col">Thành tiền</th>
                            <th scope="col">Họ và tên</th>
                            <th scope="col">Số điện thoại</th>
                            <th scope="col">Trạng thái</th>
                            <th scope="col">Chi tiết</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                </table>
            </div>
        </div>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gREQUEST_DELETE_SUCCESS = 204;

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
             /**
            * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
            */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            var vRespone = JSON.parse(paramXMLHttpAllOrder.responseText);
            console.log(vRespone);
                var vTable = document.getElementById("table-order");
                var vTableBody = vTable.getElementsByTagName("tbody")[0];
                var vTableHead = vTable.getElementsByTagName("thead")[0];
                for (var bI = 0 ; bI < vRespone.length;bI ++ ) {
                    var vNewRow = vTableBody.insertRow(-1);
                    var vNewCellOder = vNewRow.insertCell(0);
                    var vNewCellKickCo = vNewRow.insertCell(1);
                    var vNewCellLoaiPizza = vNewRow.insertCell(2);
                    var vNewCellNuocUong = vNewRow.insertCell(3);
                    var vNewCellThanhTien = vNewRow.insertCell(4);
                    var vNewCellHovaTen = vNewRow.insertCell(5);
                    var vNewCellDienThoai = vNewRow.insertCell(6);
                    var vNewCellTrangThai = vNewRow.insertCell(7);
                    var vNewCellChiTiet = vNewRow.insertCell(8);
                    vNewCellOder.innerText = vRespone[bI].orderCode;
                    vNewCellKickCo.innerText = vRespone[bI].kichCo;
                    vNewCellLoaiPizza.innerText = vRespone[bI].loaiPizza;
                    vNewCellNuocUong.innerText = vRespone[bI].idLoaiNuocUong;
                    vNewCellThanhTien.innerText = vRespone[bI].thanhTien;
                    vNewCellHovaTen.innerText = vRespone[bI].hoTen;
                    vNewCellDienThoai.innerText = vRespone[bI].soDienThoai;
                    vNewCellTrangThai.innerText = vRespone[bI].trangThai;
                    var vButton = document.createElement("button");
                    var vButtonDelete = document.createElement("button");
                    vButton.innerText = "Chi tiết";
                    vButtonDelete.innerText = "Delete";
                    vButton.className = "btn btn-info";
                    vButtonDelete.className = "btn btn-danger";
                    vButton.getAttribute("data-id");
                    vButtonDelete.getAttribute("data-id");
                    vButton.getAttribute("data-ordercode");
                    vButton.dataset.id = vRespone[bI].id;
                    vButtonDelete.dataset.id = vRespone[bI].id;
                    vButton.dataset.ordercode = vRespone[bI].orderCode;
                    vButton.addEventListener("click" , function() {
                        onBtnDatasetClick(this);
                    })
                    vButtonDelete.addEventListener("click" , function() {
                        onBtnDeleteClick(this);
                    })
                    vNewCellChiTiet.appendChild(vButton);
                    vNewCellChiTiet.appendChild(vButtonDelete);

                }
                function onBtnDatasetClick(paramButton) {
                        console.log("Oder Code: " + paramButton.dataset.ordercode);
                        var vOderCode = paramButton.dataset.ordercode;
                        var vId = paramButton.dataset.id;
                        const vDETAIL_FORM_URL = "oderdetail.html";
                        var vUrlSiteToOpen = vDETAIL_FORM_URL +
                        "?odercode=" + vOderCode + "&id=" + vId;
                        window.location.href = vUrlSiteToOpen;
                }
                function onBtnDeleteClick(paramButton) {
                   var vConfirm =  confirm("Bạn có chắc chắn muốn xóa đơn hàng này không");
                   if (vConfirm === true) {
                    var vId = paramButton.dataset.id;
                    var vXmlHttpOrder = new XMLHttpRequest();
                    callApiToDeleteOrders(vId,vXmlHttpOrder);
                    hienThiKetQua(vXmlHttpOrder,vId);
                   }

                }
                function callApiToDeleteOrders(paramid,paramXMLHttp) {
                           //base url
                        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
                        var vId = paramid; //  là id (66684) của order cần xóa
                        paramXMLHttp.open("DELETE", vBASE_URL + "/" + vId, true);
                        paramXMLHttp.send();
                }
                function hienThiKetQua(paramXMLHttp,paramid) {
                    paramXMLHttp.onreadystatechange = function () {
                            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK 
                                && this.status == gREQUEST_DELETE_SUCCESS) {
                                alert("Delete order có id " + paramid + " thành công!");
                            }
                        }
                }
        }
        
    </script>
</body>

</html>